/*
 * 
 * Copyright 2004 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the Sun Community Source
 * License v3.0/Jini Technology Specific Attachment v 1.0 (the
 * "License"). You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://wwws.sun.com/software/jini/licensing/SCSL3_JiniTSA1.html.
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Reference Code is Jini Technology Core Platform code, v2.0. The
 * Developer of the Reference Code is Sun Microsystems, Inc.
 * 
 * Contributor(s): Sun Microsystems, Inc.
 * 
 * The contents of this file comply with the Jini Technology Core
 * Platform Compatibility Kit, v2.0A.
 * 
 * Tester(s): Sun Microsystems, Inc.
 * 
 * Test Platform(s):
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Solaris(TM)SPARC/x86
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Linux (Intel x86)
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Windows (Intel Platform)
 * 
 */

package com.sun.jini.discovery;

import java.io.IOException;
import java.io.InvalidObjectException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import net.jini.core.constraint.InvocationConstraint;

/**
 * Represents a constraint on the version of the discovery protocol used to
 * contact lookup services.  Lookup services and discovery clients can use this
 * constraint to control what version(s) of the multicast request, multicast
 * announcement and unicast discovery protocols are used to exchange data with
 * each other.
 *
 * @author Sun Microsystems, Inc.
 * @since 2.0
 */
public final class DiscoveryProtocolVersion
    implements InvocationConstraint, Serializable
{
    private static final long serialVersionUID = 1781016120938012150L;

    /** Use discovery protocol version 1. */
    public static final DiscoveryProtocolVersion ONE =
	new DiscoveryProtocolVersion(Discovery.PROTOCOL_VERSION_1);

    /** Use discovery protocol version 2. */
    public static final DiscoveryProtocolVersion TWO =
	new DiscoveryProtocolVersion(Discovery.PROTOCOL_VERSION_2);

    /**
     * The protocol version number.
     *
     * @serial
     */
    private final int version;

    /**
     * Returns a <code>DiscoveryProtocolVersion</code> constraint for the given
     * version number.
     *
     * @return a constraint for the given version number
     */
    public static DiscoveryProtocolVersion getInstance(int version) {
	switch (version) {
	    case Discovery.PROTOCOL_VERSION_1:
		return ONE;
	    case Discovery.PROTOCOL_VERSION_2:
		return TWO;
	    default:
		return new DiscoveryProtocolVersion(version);
	}
    }

    private DiscoveryProtocolVersion(int version) {
	if (version <= 0) {
	    throw new IllegalArgumentException("invalid version");
	}
	this.version = version;
    }

    /**
     * Returns the protocol version number.
     *
     * @return the protocol version number
     */
    public int getVersion() {
	return version;
    }

    public int hashCode() {
	return DiscoveryProtocolVersion.class.hashCode() + version;
    }

    public boolean equals(Object obj) {
	return obj instanceof DiscoveryProtocolVersion &&
	       version == ((DiscoveryProtocolVersion) obj).version;
    }

    public String toString() {
	return "DiscoveryProtocolVersion[" + version + "]";
    }

    private void readObject(ObjectInputStream in)
	throws IOException, ClassNotFoundException
    {
	in.defaultReadObject();
	if (version <= 0) {
	    throw new InvalidObjectException("invalid version");
	}
    }
}
